#!/usr/local/bin/perl
#### ȼ for GNS cm.cgi V4.00 
#### Copyright 1998-2005 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### History: 
#### 2005/04/22 V4.00  

require "tb.ph";
require "config.ph";

if ( $CM_RECEIVE == 0 ) {
	&err_refused();
	exit;
}

{
	&CreateSemaphore();

	$SYSTIME = time;
	( $S_sec,$S_min,$S_hour,$S_mday,$S_mon,$S_year,$S_wday,$S_yday,$S_isdst ) = localtime( $SYSTIME );
	$S_date = sprintf( "%04d/%02d/%02d %02d:%02d:%02d", $S_year+1900, $S_mon+1, $S_mday+0, $S_hour+0, $S_min+0, $S_sec+0 );

	$tbtourl = substr( $ENV{'PATH_INFO'}, 1 );

	if ( $ENV{'REQUEST_METHOD'} eq "POST" ) {
		$len = $ENV{'CONTENT_LENGTH'} + 0;
		read( STDIN, $param, $len );
	} else {
		&err_method();
		die;
	}

	# 
	@part = split( '&', $param );
	foreach $i (@part) {
		( $variable, $value ) = split( '=', $i );
		$value =~ tr/+/ /;
		$value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
#		&jcode'convert( *value, 'sjis' );
		$value =~ s/\015\012/\012/g;
		$value =~ s/\015/\012/g;
		$cgi{$variable} = $value;
	}
	$param =~ s/[\015\012]+//g;

	# å
	$year = substr( $tbtourl, 0, 4 )+0;
	$month = substr( $tbtourl, 4, 2 )+0;
	$day = substr( $tbtourl, 6, 2 )+0;
	$titleid = substr( $tbtourl, 8, 2 )+0;
	if ( ($year < 1980) || ($year > 2099)
	  || ($month < 1) || ($month > 12)
	  || ($day < 1) || ($day > 31)
	  || ($titleid < 1)
	) {
		&err_overrange( $tbtourl );
		die;
	}

	if ( $cgi{'GNSname'} eq "" ) {
		&err_noname( $tbtourl );
		die;
	}
	if ( ($cgi{'GNSname'} eq "") || ($cgi{'GNScomment'} eq "") ) {
		&err_nocomment( $tbtourl );
		die;
	}

	# Ƹ
	$http_user_agent = $ENV{"HTTP_USER_AGENT"};
	$remote_addr = $ENV{"REMOTE_ADDR"};
	$remote_host = $ENV{"REMOTE_HOST"};
	if ( $remote_host eq "" ) {
		$remote_host = $remote_addr;
	}
	if ( $remote_host eq $remote_addr ) {
		$remote_host = gethostbyaddr( pack( 'C4', split( /[.]/, $remote_addr ) ), 2 ) || $remote_addr;
	}

	# ǥ
	open( FOUT, "|$TB_NKFCMD -e > $TB_LOG_DIR/%tbarg.txt" );
	foreach $i (keys(%cgi)) {
		print FOUT "$i: $cgi{$i}\n";
	}
	close( FOUT );
	undef( %post2 );
	open( FIN, "$TB_LOG_DIR/%tbarg.txt" );
	while( <FIN> ) {
		chomp;
		if ( $_ =~ m/^([^:]*): (.*)$/ ) {
			$post2{$1} = $2;
		}
	}
	close( FIN );
	unlink( "$TB_LOG_DIR/%tbarg.txt" );

	# ե륿
	open( FIN, "$TB_NKFCMD -e cmfilter.txt|" );
	while( <FIN> ) {
		chomp;
		next if ( $_ =~ m/^#/ );
		if ( $_ =~ m/^([^:]*): (.*)$/ ) {
			$cmd = $1;
			$arg = $2;
			if ( $cmd eq "name" ) {
				if ( $post2{"GNSname"} =~ m/${arg}/ ) {
					&err_refused( "by name filter" );
					die;
				}
			} elsif ( $cmd eq "comment" ) {
				if ( $post2{"GNScomment"} =~ m/${arg}/ ) {
					&err_refused( "by comment filter" );
					die;
				}
			} elsif ( $cmd eq "fromadr" ) {
				if ( ($remote_addr =~ m/${arg}/) ||
				     ($remote_host =~ m/${arg}/) ) {
					&err_refused( "by fromadr filter" );
					die;
				}
			}
		}
	}

	# ̥ե
	if ( !(-e "$TB_LOG_DIR/$year") ) {
		$umaskback = umask( oct($TB_LOG_DIR_PERM) ^ 0777 );
		mkdir( "$TB_LOG_DIR/$year", oct($TB_LOG_DIR_PERM) ) || die "cannot create directory [$TB_LOG_DIR/$year].";
		umask( $umaskback );
	}

	$umaskback = umask( oct($TB_LOG_PERM) ^ 0666 );

	# ̥¸
	$fout = sprintf( "$TB_LOG_DIR/$year/%02d.log", $month );
	open( FOUT, ">>$fout" ) || die "[$fout] cannot write. Check [$fout] permission.";
	print FOUT "$tbtourl $param COMMENT $S_date $remote_addr $remote_host \"$http_user_agent\"\n";
	close( FOUT );

	# ǿ¸
	$fout = "$TB_LOG_DIR/latestcm.log";
	open( FIN, "$fout" );
	$lines = 0;
	while ( <FIN> ) {
		$line[$lines++] = $_;
	}
	close( FIN );
	$line[$lines++] = "$tbtourl $param COMMENT $S_date $remote_addr $remote_host \"$http_user_agent\"\n";
	$ls = $lines - $TB_LATEST_N;
	$ls = 0 if ( $ls < 0 );
	open( FOUT, ">$fout" ) || die "[$fout] cannot write. Check [$fout] permission.";
	for ( $i=$ls; $i<$lines; $i++ ) {
		print FOUT $line[$i];
	}
	close( FOUT );

	umask( $umaskback );

	&doterm();

	# ȥӥ塼ڡ
	if ( $TBCM_MAKEVIEW ) {
		chdir( $TB_MKTBVIEW_PATH );
		system( "$TB_PERLCMD $TB_MKTBVIEW_PL $year $month $day" );
	}

	# Υ᡼
	if ( $CM_NOTIFYMAIL ) {
		$cmd = sprintf( "| $TB_NKFCMD -j | $TB_MAILCMD -s \"$TB_MAILSUBJECT %04d/%02d/%02d-%02d\" $TBCM_MAILTO", $year, $month, $day, $titleid );
# print "$cmd\n";
		if ( !open( CMD, $cmd ) ) {
			&err_sendmail( $cmd );
			die;
		}
		$name = $cgi{'GNSname'};
		$name =~ tr/+/ /;
		$name =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		$comment = $cgi{'GNScomment'};
		$comment =~ tr/+/ /;
		$comment =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
		printf( CMD "Receive Comment from: %s\n  %s\n", $name, $comment );
		printf( CMD "to following title:\n  $TBCM_BASEURL%04d%02dt.html#$TB_ANCHOR%02d%02dcm\n", $year, $month, $day, $titleid );
		print CMD "\n";
		close( CMD );
	}

	# ơ֤
	$url = sprintf( "%s%04d%02dt.html#%02d%02d", $TBCM_BASEURL, $year, $month, $day, $titleid );
	printf(
	  "Content-Type: text/html;\n\n" .
	  "<html>\n" .
	  "<head><meta http-equiv=\"refresh\" content=\"0; URL=$url\"></head>\n" .
	  "<body><div><a href=\"$url\">$url</a></div></body>\n" .
	  "</html>\n"
	);

}

########################################################################

sub err_refused {
	local($s) = @_;
	print <<message;
Content-Type: text/plain;

Refused.\n[$s]
message
}

sub err_method {
	print <<message;
Content-Type: text/plain;

This CGI can receive only POST method.
message
}

sub err_overrange {
	local($s) = @_;
	print <<message;
Content-Type: text/plain;

Comment ID($s) Range Over.
message
}

sub err_noname {
	print <<message;
Content-Type: text/plain;

Comment Needs "Name".
message
}

sub err_nocomment {
	print <<message;
Content-Type: text/plain;

Comment Needs "Comment".
message
}

sub err_sendmail {
	local($s) = @_;
	print <<message;
Content-Type: text/plain;

Cannot send notify mail.\n[$s]
message
}

####################################################################

sub CreateSemaphore {
	local( $abort_counter ) = 60;
	local( $not_aborted ) = 1;
	$SIG{'__DIE__'} = $SIG{'TRAP'} = $SIG{'ABRT'} = $SIG{'STOP'} = $SIG{'TERM'} = $SIG{'INT'} = $SIG{'KILL'} = $SIG{'QUIT'} = $SIG{'HUP'} = $SIG{'PIPE'} = 'doterm';
	while(!mkdir($LOCKFILE)) {
		$abort_counter--;
		if ( $abort_counter eq 0 ) {
			$not_aborted = 0;
			last;
		}
		sleep(1);
	}

	if ( $not_aborted == 0 ) {
		&doterm();
		print "Content-Type: text/plain\n\n";
		print "Cannot create semaphore.  Please contact diary owner.\n";
		die "Cannot create semaphore [$LOCKFILE].";
	}

	return (0);
}

sub doterm {
	rmdir($LOCKFILE);
	return;
}

####################################################################

# [EOF]
